Subject: [PATCH] [FEAT LS1201] zdsfs: add new tool to access z/OS data sets
From: Stefan Weinhuber <wein@de.ibm.com>

Summary:     zdsfs: add new tool to access z/OS data sets
Description: This feature introduces the new tool zdsfs, which is a FUSE file
             system that allows access to z/OS data sets. This tool works on
             DASD devices with enabled raw track access mode.
             The tool dasdview now also supports devices in raw track access
             mode.
Upstream-ID: -
Problem-ID:  LS1201

Signed-off-by: Stefan Weinhuber <wein@de.ibm.com>
---
 Makefile            |    4 
 dasdview/Makefile   |    6 
 dasdview/dasdview.8 |   39 
 dasdview/dasdview.c | 1296 ++++++++++++++---
 dasdview/dasdview.h |   12 
 include/libzds.h    |  812 +++++++++++
 include/vtoc.h      |   15 
 libzds/Makefile     |   22 
 libzds/libzds.c     | 3774 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 zdsfs/Makefile      |   22 
 zdsfs/zdsfs.1       |  270 +++
 zdsfs/zdsfs.c       | 1032 ++++++++++++++
 12 files changed, 7029 insertions(+), 275 deletions(-)

--- a/Makefile
+++ b/Makefile
@@ -3,11 +3,11 @@ ARCH := $(shell uname -m | sed -e s/i.86
 # Include commond definitions
 include common.mak
 
-LIB_DIRS = libvtoc libu2s libutil
+LIB_DIRS = libvtoc libu2s libutil libzds
 SUB_DIRS = $(LIB_DIRS) zipl zdump fdasd dasdfmt dasdview tunedasd \
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
-	   ziomon iucvterm hyptop cmsfs-fuse cpumf
+	   ziomon iucvterm hyptop cmsfs-fuse cpumf zdsfs
 
 all: subdirs_make
 
--- a/dasdview/Makefile
+++ b/dasdview/Makefile
@@ -1,12 +1,14 @@
 include ../common.mak
 
 CPPFLAGS += -I../include -DSYSFS
+LDLIBS += -lzds
+LDFLAGS += -L../libzds
 
 all: dasdview
 
-dasdview.o: dasdview.h ../include/zt_common.h
+dasdview.o: dasdview.h ../include/zt_common.h ../include/libzds.h
 
-dasdview: dasdview.o ../libvtoc/vtoc.o ../libu2s/u2s.o
+dasdview: dasdview.o ../libu2s/u2s.o
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
--- a/dasdview/dasdview.c
+++ b/dasdview/dasdview.c
@@ -2,7 +2,7 @@
  * File...........: s390-tools/dasdview/dasdview.c
  * Author(s)......: Volker Sameske <sameske@de.ibm.com>
  *                  Gerhard Tonn   <ton@de.ibm.com>
- * Copyright IBM Corp. 2001, 2006.
+ * Copyright IBM Corp. 2001, 2013.
  */
 
 #define _LARGEFILE64_SOURCE    /* needed for unistd.h */
@@ -17,6 +17,7 @@
 #include <getopt.h>
 #include <stdarg.h>
 #include <ctype.h>
+#include <malloc.h>
 
 #include <sys/stat.h>
 #include <sys/ioctl.h>
@@ -28,6 +29,8 @@
 #include "vtoc.h"
 #include "dasdview.h"
 #include "u2s.h"
+#include "libzds.h"
+
 
 /* Characters per line */
 #define DASDVIEW_CPL 16
@@ -42,6 +45,8 @@ static const char copyright_notice[] = "
 #define ERROR_STRING_SIZE       1024
 static char error_string[ERROR_STRING_SIZE];
 
+#define min(x, y) ((x) > (y) ? (y) : (x))
+
 /*
  * Generate and print an error message based on the formatted
  * text string FMT and a variable amount of extra arguments.
@@ -74,7 +79,7 @@ dasdview_usage(void)
 	printf("\nprints DASD information:\n\n");
 	printf("dasdview [-b begin] [-s size] [-1|-2] \n"
 	       "         [-i] [-x] [-j] [-c]\n"
-	       "         [-l] [-t {info|f1|f4|f5|f7|f8|f9|all}] \n"
+	       "         [-l] [-t {info|f1|f3|f4|f5|f7|f8|f9|all}] \n"
 	       "         [-h] [-v] \n"
 	       "         {-n devno|-f node} device\n"
 	       "\nwhere:\n"
@@ -165,11 +170,38 @@ dot (char label[]) {
 	}
 }
 
+
+/*
+ * Attempts to find the sysfs entry for the given busid and reads
+ * the contents of a specified attribute to the buffer
+ */
+static int dasdview_read_attribute(char *busid, char *attribute, char *buffer,
+				   size_t count)
+{
+	char path[100];
+	int rc, fd;
+	ssize_t rcount;
+
+	rc = 0;
+	snprintf(path, sizeof(path), "/sys/bus/ccw/devices/%s/%s",
+		 busid, attribute);
+	fd = open(path, O_RDONLY);
+	if (fd < 0)
+		return errno;
+	rcount = read(fd, buffer, count);
+	if (rcount < 0)
+		rc = errno;
+	close(fd);
+	return rc;
+}
+
 static void
 dasdview_get_info(dasdview_info_t *info)
 {
 	int fd;
 	struct dasd_eckd_characteristics *characteristics;
+	char buffer[10];
+	int rc;
 
 	fd = open(info->device, O_RDONLY);
 	if (fd == -1)
@@ -221,9 +253,23 @@ dasdview_get_info(dasdview_info_t *info)
 		info->hw_cylinders = characteristics->long_no_cyl;
 	else
 		info->hw_cylinders = characteristics->no_cyl;
+	close(fd);
 
 
-	close(fd);
+	if(u2s_getbusid(info->device, info->busid) == -1)
+		info->busid_valid = 0;
+	else
+		info->busid_valid = 1;
+
+	rc = dasdview_read_attribute(info->busid, "raw_track_access", buffer,
+				sizeof(buffer));
+	if (rc) {
+		zt_error_print("dasdview: Could not retrieve raw_track_access"
+			       " mode information.");
+		return;
+	}
+	if ('1' == buffer[0])
+		info->raw_track_access = 1;
 }
 
 
@@ -244,27 +290,53 @@ dasdview_parse_input(unsigned long long
 		suffix = tolower(*endp);
 	} else
 		suffix = 0;
-	switch (suffix) {
-	case 'k':
-		l *= 1024LL;
-		break;
-	case 'm':
-		l *= 1024LL * 1024LL;
-		break;
-	case 't':
-		l *= (unsigned long long) info->blksize *
-		     (unsigned long long) info->geo.sectors;
-		break;
-	case 'b':
-		l *= (unsigned long long) info->blksize;
-		break;
-	case 'c':
-		l *= (unsigned long long) info->blksize *
-		     (unsigned long long) info->geo.sectors *
-		     (unsigned long long) info->geo.heads;
-		break;
-	default:
-		break;
+	if (info->raw_track_access) {
+		switch (suffix) {
+		case 't':
+			l *= RAWTRACKSIZE;
+			break;
+		case 'c':
+			l *= (unsigned long long) info->geo.heads *
+				RAWTRACKSIZE;
+			break;
+		case 0:
+			if (l % RAWTRACKSIZE) {
+				zt_error_print("dasdview: only full tracks can"
+					     " be accessd on devices with "
+					     " raw_track_access enabled.\n", s);
+
+				goto error;
+			}
+			break;
+		default:
+			zt_error_print("dasdview: only types t and c are"
+				       " allowed for devices with"
+				       " raw_track_access enabled.\n", s);
+			goto error;
+		}
+	} else {
+		switch (suffix) {
+		case 'k':
+			l *= 1024LL;
+			break;
+		case 'm':
+			l *= 1024LL * 1024LL;
+			break;
+		case 't':
+			l *= (unsigned long long) info->blksize *
+				(unsigned long long) info->geo.sectors;
+			break;
+		case 'b':
+			l *= (unsigned long long) info->blksize;
+			break;
+		case 'c':
+			l *= (unsigned long long) info->blksize *
+				(unsigned long long) info->geo.sectors *
+				(unsigned long long) info->geo.heads;
+			break;
+		default:
+			break;
+		}
 	}
 	*p = l;
 
@@ -289,22 +361,19 @@ dasdview_print_general_info(dasdview_inf
 	unsigned char a,b,c;
 	char suffix[sizeof(buf.release)];
 	int rc;
-	char busid[U2S_BUS_ID_SIZE];
 
 	rc = uname(&buf);
 	if(!rc)
 	{
 		sscanf(buf.release, "%c.%c.%c-%s", &a, &b, &c, suffix);
-		if(KERNEL_VERSION(2,5,0) <= KERNEL_VERSION(a, b, c))
-		{
-			if(u2s_getbusid(info->device, busid) == -1)
+		if(KERNEL_VERSION(2,5,0) <= KERNEL_VERSION(a, b, c)) {
+			if (info->busid_valid)
+				printf("busid                  : %s\n",
+				       info->busid);
+			else
 				printf("busid                  :"
 				       " <not found>\n");
-			else
-				printf("busid                  : %s\n", busid);
-		}
-		else
-		{
+		} else {
 #endif
 			printf("device number          : hex %x  \tdec %d\n",
 			       info->dasd_info.devno,
@@ -461,12 +530,23 @@ static void
 dasdview_print_vlabel(dasdview_info_t *info)
 {
 	volume_label_t vlabel;
-
+	volume_label_t *tmpvlabel;
+	int rc;
 	unsigned char s4[5], t4[5], s5[6], t5[6], s6[7], t6[7];
 	char s14[15], t14[15], s29[30], t29[30];
 	int i;
 
-	dasdview_read_vlabel(info, &vlabel);
+	if (info->raw_track_access) {
+		rc = lzds_dasd_read_vlabel(info->dasd);
+		if (rc) {
+			zt_error_print("error when reading label from device:"
+				       " rc=%d\n", rc);
+			exit(-1);
+		}
+		lzds_dasd_get_vlabel(info->dasd, &tmpvlabel);
+		memcpy(&vlabel, tmpvlabel, sizeof(vlabel));
+	} else
+		dasdview_read_vlabel(info, &vlabel);
 
 	printf("\n--- volume label -----------------------------" \
 	       "---------------------------------\n");
@@ -586,10 +666,22 @@ static void
 dasdview_print_volser(dasdview_info_t *info)
 {
 	volume_label_t vlabel;
+	volume_label_t *tmpvlabel;
 	char           volser[7];
 	char           vollbl[5];
+	int rc;
 
-	dasdview_read_vlabel(info, &vlabel);
+	if (info->raw_track_access) {
+		rc = lzds_dasd_read_vlabel(info->dasd);
+		if (rc) {
+			zt_error_print("error when reading label from device:"
+				       " rc=%d\n", rc);
+			exit(-1);
+		}
+		lzds_dasd_get_vlabel(info->dasd, &tmpvlabel);
+		memcpy(&vlabel, tmpvlabel, sizeof(vlabel));
+	} else
+		dasdview_read_vlabel(info, &vlabel);
 
 	bzero(vollbl, 5);
 	bzero(volser, 7);
@@ -806,14 +898,268 @@ static void dasdview_print_vtoc_info(das
 	}
 }
 
+static void dasdview_print_short_info_extent_raw(extent_t *ext)
+{
+	if (ext->typeind > 0x00)
+		printf("   %3d          (%5d,%5d)        (%5d,%5d)\n",
+		       ext->seqno,
+		       vtoc_get_cyl_from_cchh(&ext->llimit),
+		       vtoc_get_head_from_cchh(&ext->llimit),
+		       vtoc_get_cyl_from_cchh(&ext->ulimit),
+		       vtoc_get_head_from_cchh(&ext->ulimit));
+}
+
+static void dasdview_print_format1_8_short_info_raw(format1_label_t *f1,
+						    dasdview_info_t *info)
+{
+	char s6[7], s13[14], s44[45];
+	unsigned long long j;
+	format3_label_t *f3;
+	format9_label_t *f9;
+	struct dscb *dscb;
+	int rc;
+
+	bzero(s44, 45);
+	strncpy(s44, f1->DS1DSNAM, 44);
+	vtoc_ebcdic_dec(s44, s44, 44);
+	bzero(s6, 7);
+	strncpy(s6, (char *)f1->DS1DSSN, 6);
+	vtoc_ebcdic_dec(s6, s6, 6);
+	bzero(s13, 14);
+	strncpy(s13, (char *)f1->DS1SYSCD, 13);
+	vtoc_ebcdic_dec(s13, s13, 13);
+
+	printf("data set name          : '%44s'\n", s44);
+	printf("data set serial number : '%6s'\n", s6);
+	printf("system code            : '%13s'\n", s13);
+	printf("creation date          :  year %4d, day %3d\n",
+	       f1->DS1CREDT.year + 1900, f1->DS1CREDT.day);
+
+	printf("flags                  :  ");
+	if (f1->DS1FLAG1 & 0x80)
+		printf("DS1COMPR ");
+	if (f1->DS1FLAG1 & 0x40)
+		printf("DS1CPOIT ");
+	if (f1->DS1FLAG1 & 0x20)
+		printf("DS1EXPBY ");
+	if (f1->DS1FLAG1 & 0x10)
+		printf("DS1RECAL ");
+	if (f1->DS1FLAG1 & 0x08)
+		printf("DS1LARGE ");
+	if (f1->DS1FLAG1 & 0x04)
+		printf("unknown ");
+	if ((f1->DS1FLAG1 & 0x01) && (f1->DS1FLAG1 & 0x02))
+		printf("DS1EATTR=not used ");
+	if (!(f1->DS1FLAG1 & 0x01) && (f1->DS1FLAG1 & 0x02))
+		printf("DS1EATTR=optional ");
+	if ((f1->DS1FLAG1 & 0x01) && !(f1->DS1FLAG1 & 0x02))
+		printf("DS1EATTR=no ");
+	if (f1->DS1FLAG1 & 0x00)
+		printf("DS1EATTR=default ");
+	printf("\n");
+
+	printf("SMS flags              :  ");
+	if (f1->DS1SMSFG & 0x80)
+		printf("DS1SMSDS ");
+	if (f1->DS1SMSFG & 0x40)
+		printf("DS1SMSUC ");
+	if (f1->DS1SMSFG & 0x20)
+		printf("DS1REBLK ");
+	if (f1->DS1SMSFG & 0x10)
+		printf("DS1CRSDB ");
+	if (f1->DS1SMSFG & 0x08)
+		printf("DS1PDSE ");
+	if (f1->DS1SMSFG & 0x04)
+		printf("DS1STRP ");
+	if (f1->DS1SMSFG & 0x02)
+		printf("DS1PDSEX ");
+	if (f1->DS1SMSFG & 0x01)
+		printf("DS1DSAE ");
+	printf("\n");
+
+	printf("organisation           :  ");
+	if (f1->DS1DSRG1 & 0x80)
+		printf("DS1DSGIS ");
+	if (f1->DS1DSRG1 & 0x40)
+		printf("DS1DSGPS ");
+	if (f1->DS1DSRG1 & 0x20)
+		printf("DS1DSGDA ");
+	if (f1->DS1DSRG1 & 0x10)
+		printf("DS1DSGCX ");
+	if (f1->DS1DSRG1 & 0x08)
+		printf("reserved ");
+	if (f1->DS1DSRG1 & 0x04)
+		printf("reserved ");
+	if (f1->DS1DSRG1 & 0x02)
+		printf("DS1DSGPO ");
+	if (f1->DS1DSRG1 & 0x01)
+		printf("DS1DSGU ");
+	if (f1->DS1DSRG2 & 0x80)
+		printf("DS1DSGGS ");
+	if (f1->DS1DSRG2 & 0x40)
+		printf("DS1DSGTX ");
+	if (f1->DS1DSRG2 & 0x20)
+		printf("DS1DSGTQ ");
+	if (f1->DS1DSRG2 & 0x10)
+		printf("reserved ");
+	if (f1->DS1DSRG2 & 0x08)
+		printf("DS1ACBM ");
+	if (f1->DS1DSRG2 & 0x04)
+		printf("DS1DSGTR ");
+	if (f1->DS1DSRG2 & 0x02)
+		printf("reserved ");
+	if (f1->DS1DSRG2 & 0x01)
+		printf("reserved");
+	printf("\n");
+
+	printf("record format          :  ");
+	if ((f1->DS1RECFM & 0x80) && !(f1->DS1RECFM & 0x40))
+		printf("DS1RECFF ");
+	if (!(f1->DS1RECFM & 0x80) && (f1->DS1RECFM & 0x40))
+		printf("DS1RECFV ");
+	if ((f1->DS1RECFM & 0x80) && (f1->DS1RECFM & 0x40))
+		printf("DS1RECFU ");
+	if (f1->DS1RECFM & 0x20)
+		printf("DS1RECFT ");
+	if (f1->DS1RECFM & 0x10)
+		printf("DS1RECFB ");
+	if (f1->DS1RECFM & 0x08)
+		printf("DS1RECFS ");
+	if (f1->DS1RECFM & 0x04)
+		printf("DS1RECFA ");
+	if (f1->DS1RECFM & 0x02)
+		printf("DS1RECMC ");
+	if (f1->DS1RECFM & 0x01)
+		printf("reserved");
+	printf("\n");
+
+	printf("(max) block length     :  %u\n", f1->DS1BLKL);
+	printf("logical record length  :  %u\n", f1->DS1LRECL);
+
+	printf("extents belonging to this dataset:\n");
+	printf("  seqno        llimit (cyl, trk)    ulimit (cyl, trk)\n");
+
+	/* The format 1 label can point to a chain of f3 labels
+	 * The format 8 label points to a (chain of) f9 labels
+	 * The format 9 label may contain several format 3 labels, but as
+	 * far as I know, it is still OK to follow the 'next dscb' chain.
+	 * So for a format 9 label I have to follow this chain until I
+	 * find the first format 3 dscb and then I can follow the format 3
+	 * dscbs to the end of the chain.
+	 */
+	rc = lzds_raw_vtoc_get_dscb_from_cchhb(info->rawvtoc, &f1->DS1PTRDS,
+					       &dscb);
+	/* The first f9 label contains extra data that we may want
+	 * to print here */
+	while (!rc && dscb && dscb->fmtid == 0xf9) {
+		f9 = (format9_label_t *)dscb;
+		rc = lzds_raw_vtoc_get_dscb_from_cchhb(info->rawvtoc,
+						       &f9->DS9PTRDS, &dscb);
+	}
+	if (rc) {
+		zt_error_print("dasdview: Broken format 3 DSCB"
+			       " chain \n");
+		exit(-1);
+	}
+	f3 = (dscb && dscb->fmtid == 0xf3) ? (format3_label_t *)dscb : NULL;
+
+	/* first print the extents that are part of the f1/f8 label itself */
+	dasdview_print_short_info_extent_raw(&f1->DS1EXT1);
+	dasdview_print_short_info_extent_raw(&f1->DS1EXT2);
+	dasdview_print_short_info_extent_raw(&f1->DS1EXT3);
+
+	/* now follow the f3 chain into the rabbit hole */
+	while (f3) {
+		/* sanity check */
+		if (f3->DS3FMTID != 0xf3) {
+			zt_error_print("dasdview: Broken format 3 DSCB"
+				       " chain \n");
+			exit(-1);
+		}
+		for (j = 0; j < 4; ++j)
+			dasdview_print_short_info_extent_raw(&f3->DS3EXTNT[j]);
+		for (j = 0; j < 9; ++j)
+			dasdview_print_short_info_extent_raw(&f3->DS3ADEXT[j]);
+		rc = lzds_raw_vtoc_get_dscb_from_cchhb(info->rawvtoc,
+						       &f3->DS3PTRDS,
+						       (struct dscb **)&f3);
+		if (rc) {
+			zt_error_print("dasdview: Broken format 3 DSCB"
+				       " chain \n");
+			exit(-1);
+		}
+	}
+	printf("\n");
+}
+
+static void dasdview_print_vtoc_info_raw(dasdview_info_t *info)
+{
+	struct dscbiterator *it;
+	struct dscb *dscb;
+	int rc;
+	int f1c, f3c, f4c, f5c, f7c, f8c, f9c;
+
+	f1c = 0;
+	f3c = 0;
+	f4c = 0;
+	f5c = 0;
+	f7c = 0;
+	f8c = 0;
+	f9c = 0;
+	rc = lzds_raw_vtoc_alloc_dscbiterator(info->rawvtoc, &it);
+	if (rc) {
+		zt_error_print("dasdview: could not allocate DSCB iterator \n");
+		exit(-1);
+	}
+	while (!lzds_dscbiterator_get_next_dscb(it, &dscb)) {
+		if (dscb->fmtid == 0xf1)
+			++f1c;
+		else if (dscb->fmtid == 0xf3)
+			++f3c;
+		else if (dscb->fmtid == 0xf4)
+			++f4c;
+		else if (dscb->fmtid == 0xf5)
+			++f5c;
+		else if (dscb->fmtid == 0xf7)
+			++f7c;
+		else if (dscb->fmtid == 0xf8)
+			++f8c;
+		else if (dscb->fmtid == 0xf9)
+			++f9c;
+	}
+	lzds_dscbiterator_free(it);
+	printf("--- VTOC info --------------------------------" \
+	       "---------------------------------\n");
+	printf("The VTOC contains:\n");
+	printf("  %d format 1 label(s)\n", f1c);
+	printf("  %d format 3 label(s)\n", f3c);
+	printf("  %d format 4 label(s)\n", f4c);
+	printf("  %d format 5 label(s)\n", f5c);
+	printf("  %d format 7 label(s)\n", f7c);
+	printf("  %d format 8 label(s)\n", f8c);
+	printf("  %d format 9 label(s)\n", f9c);
+
+	rc = lzds_raw_vtoc_alloc_dscbiterator(info->rawvtoc, &it);
+	if (rc) {
+		zt_error_print("dasdview: could not allocate DSCB iterator \n");
+		exit(-1);
+	}
+	while (!lzds_dscbiterator_get_next_dscb(it, &dscb)) {
+		if (dscb->fmtid == 0xf1 || dscb->fmtid == 0xf8)
+			dasdview_print_format1_8_short_info_raw(
+				(format1_label_t *)dscb, info);
+	}
+	lzds_dscbiterator_free(it);
+}
+
+
 /*
  * Note: the explicit cylinder/head conversion for large volume
  * adresses should not be necessary for entries that point to
  * vtoc labels, as those must be located in the first 65K-1 tracks,
  * but we do it anyway to be on the safe side.
  */
-
-static void dasdview_print_format1_8_full(format1_label_t *f1)
+static void dasdview_print_format1_8_no_head(format1_label_t *f1)
 {
 	char s6[7], s13[14], s44[45];
 	int i;
